package sun.reflect;

import java.security.AccessController;
import java.security.PrivilegedAction;
import sun.misc.Unsafe;

class ClassDefiner
{
    static final Unsafe unsafe;
    
    ClassDefiner() {
    }
    
    static Class<?> defineClass(String s, byte[] array, int n, int n2, final ClassLoader classLoader) {
        return ClassDefiner.unsafe.defineClass(s, array, n, n2, (ClassLoader)AccessController.doPrivileged(new PrivilegedAction<ClassLoader>() {
            @Override
            public ClassLoader run() {
                return new DelegatingClassLoader(classLoader);
            }
        }), null);
    }
    
    static {
        unsafe = Unsafe.getUnsafe();
    }
}
